function [mapping,eigvalues] = Apps-DAG-DNE(X_trn,Y_trn,k1,k2,dim)
% original author @Tomek
% if ~exist('no_dims','var')
%     no_dims=2;
% end

F1=zeros(size(X_trn,1),size(X_trn,1));
F2=zeros(size(X_trn,1),size(X_trn,1));
dist=L2_distance(X_trn',X_trn');
[~,index]=sort(dist,2);
for i=1:size(X_trn,1)
    temp=index(i,:);
    in1=find(Y_trn(temp)==Y_trn(i));
    in2=find(Y_trn(temp)~=Y_trn(i));
    F1(i,temp(in1(end-k1+1:end)))=1;
    F1(temp(in1(end-k1+1:end)),i)=1;
    F2(i,temp(in2(1:k2)))=1;
    F2(temp(in2(1:k2)),i)=1;
end

S1=diag(sum(F1));
S2=diag(sum(F2));

Slw=X_trn'*(S1-F1)*X_trn;
Slb=X_trn'*(S2-F2)*X_trn;

Matrix=Slb-Slw;
symMatrix=(Matrix+Matrix')./2;
symMatrix(isnan(symMatrix)) = 0;
[eigvectors,eigvalues]=eig(symMatrix+eye(size(symMatrix,1))*1.e-8);
[shu,order]=sort(diag(eigvalues),'descend');
eigvalues=shu;
eigvectors1=eigvectors(:,order);
eigenvectorslast=eigvectors1(:,1:dim);
mapping=eigenvectorslast;
end


